unit Mladez20_Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    OpenXML: TButton;
    OpenDialog1: TOpenDialog;
    mapa: TImage;
    Popisky: TCheckBox;
    Cesty: TCheckBox;
    Zobrazit: TButton;
    CestaZ: TComboBox;
    CestaDo: TComboBox;
    Hledat: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure OpenXMLClick(Sender: TObject);
    procedure ZobrazitClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure HledatClick(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Showmap(UkazujCesty:Boolean;UkazujNazvy:Boolean);
    Function Hodiny(HH:Real):String;
    Procedure Trasuj(soucasnatrasa,odkud,kam:pointer);
    Procedure ZobrazTrasu;
  end;

var
  Form1: TForm1;




implementation

uses Mladez20_trasa;

{$R *.dfm}

type TCesta=^DCesta;
     DCesta= record
        Cil:Pointer;
        Vzdalenost:Real;
        Vp:real;
        dalsi:TCesta;
     end;
     TMesta=^DMesta;
     DMesta= record
        Nazev:String;
        Koordinaty:TPoint;
        CestaPrvni:TCesta;
        dalsi:TMesta;
     end;
     TSpotreby=^DSpotreby;
     DSpotreby=record
        rychlost:real;
        spotreba:real;
        dalsi:TSpotreby;
     end;
     TTrasa=^DTrasa;
     DTrasa=record
        Delka:Real;
        Spotreba:Real;
        Rychlost:Real;
        Nazev:String;
        dalsi:TTrasa;
        dalsiKrok:TTrasa;
        predchoziKrok:TTrasa;
     end;


Var MestoPrvni:TMesta;
    SpotrebaPrvni:TSpotreby;
    TrasaPrvni:TTrasa;
    TrasaPosledni:pointer;

procedure TForm1.OpenXMLClick(Sender: TObject);
Var Soubor:TextFIle;
    MestoAkt,MestoZal:TMesta;
    CestaAkt,CestaZal,CestaAkt2:TCesta;
    SpotrebaAkt,SpotrebaZal:TSpotreby;
    Vstup:String;
    Prerusit:Boolean;

Function Hodnota(S:String):String; {Vraci parametr z XML radky}
Var Vystup:String;
begin
     Vystup:=S;
     {odkrojim <xxx> a </xxx> }
     Delete(Vystup,1,Pos('>',Vystup));
     Delete(Vystup,Pos('<',Vystup),length(Vystup));
     If Pos('.',Vystup)>0 then Vystup[Pos('.',Vystup)]:=',';
     Hodnota:=Vystup;
end;

begin
    {Osetreni vstupnich parametru}
    If OpenDialog1.Execute = false then exit;
    If OpenDialog1.FileName='' then exit;

    {Nactu soubor}
    MestoPrvni:=nil;
    SpotrebaPrvni:=nil;

    AssignFile(Soubor,OpenDialog1.FileName);
    Reset(Soubor);

    {Nactu do promennych}
    While Not Eof(Soubor) do begin
        Readln(Soubor,Vstup);
        If Pos('<NAZEV>',UpperCase(Vstup)) <> 0 then begin
          {vytvorim novy zaznam}
          New(MestoAkt);
          MestoAkt^.Nazev:=Hodnota(Vstup);
          MestoAkt^.Koordinaty.x:=0;
          MestoAkt^.Koordinaty.Y:=0;
          MestoAkt^.CestaPrvni:=nil;
          MestoAkt^.dalsi:=nil;
          If MestoPrvni=nil then MestoPrvni:=MestoAkt else MestoZal^.dalsi:=MestoAkt;
          MestoZal:=MestoAkt;
        end;
        If Pos('<POLOHAX>',UpperCase(Vstup))>0 then MestoAkt^.Koordinaty.X:=StrToInt(Hodnota(Vstup));
        If Pos('<POLOHAY>',UpperCase(Vstup))>0 then MestoAkt^.Koordinaty.Y:=StrToInt(Hodnota(Vstup));

        {Ted se nactou vzajemne vazby mezi mesty}
        If Pos('<Z>',UpperCase(Vstup))>0 then begin
          {Najdu mesto Z}
          MestoAkt:=MestoPrvni;
          While (MestoAkt<>nil) and (MestoAkt^.Nazev<>Hodnota(Vstup)) do MestoAkt:=MestoAkt^.dalsi;
        end;
        If Pos('<DO>',UpperCase(Vstup))>0 then begin
          {Najdu mesto DO, vytvorim propojku}
          MestoZal:=MestoPrvni;
          While (MestoZal<>nil) and (MestoZal^.Nazev<>Hodnota(Vstup)) do MestoZal:=MestoZal^.dalsi;
          CestaZal:=MestoAkt^.CestaPrvni;
          WHile (CestaZal<>nil) and (CestaZal^.dalsi<>nil) do CestaZal:=CestaZal^.dalsi;
          New(CestaAkt);
          CestaAkt^.Cil:=MestoZal;
          If MestoAkt^.CestaPrvni= nil then MestoAkt^.CestaPrvni:=CestaAkt else CestaZal^.dalsi:=CestaAkt;
          CestaAkt^.dalsi:=nil;
          CestaZal:=CestaAkt;
        end;
        If Pos('<VZDALENOST>',UpperCase(Vstup))>0 then
          CestaAkt^.Vzdalenost:=StrToFloat(Hodnota(Vstup));
        If Pos('<PRUMERNARYCHLOST>',UpperCase(Vstup))>0 then
          CestaAkt^.Vp:=StrToFloat(Hodnota(Vstup));

        {Tabulka spotreby}
        If Pos('<RYCHLOST>',UpperCase(Vstup))>0 then begin
          New(SpotrebaAkt);
          SpotrebaAkt^.rychlost:=StrToFloat(Hodnota(Vstup));
          SpotrebaAkt^.dalsi:=nil;
          If SpotrebaPrvni=nil then SpotrebaPrvni:=SpotrebaAkt else SpotrebaZal^.dalsi:=SpotrebaAkt;
          SpotrebaZal:=SpotrebaAkt;
        end;
        If Pos('<LITRU>',UpperCase(Vstup))>0 then
          SpotrebaAkt^.spotreba:=StrToFloat(Hodnota(Vstup));
    end;

    CloseFile(Soubor);
    ShowMap(true,true);

    CestaZ.Items.Clear;
    MestoAkt:=MestoPrvni;
    While MestoAkt<>nil do begin
      CestaZ.Items.Add(mestoAkt^.Nazev);
      MestoAkt:=MestoAkt^.DALSI;
    end;
    CestaDo.Items:=CestaZ.Items;

    {Vytvorim propojky i zpetne (bude se pak lepe hledat cesta)}
    MestoAkt:=MestoPrvni;
    While MestoAkt<>nil do begin
      CestaAkt:=MestoAkt^.CestaPrvni;
      While CestaAkt<>nil do begin
        MestoZal:=CestaAkt^.Cil;
        CestaAkt2:=MestoZal^.CestaPrvni;
        Prerusit:=false;
        While CestaAkt2<>nil do begin
          If CestaAkt2^.Cil=MestoAkt then begin
            prerusit:=true;
            break;
          end;
          CestaAkt2:=CestaAkt2^.dalsi;
        end;
        If Prerusit=false then begin
          {Vytvorim novou propojku jako "zrcadlovou kopii" te puvodni}
          CestaAkt2:=MestoZal^.CestaPrvni;
          CestaZal:=nil;
          While Cestaakt2<>nil do begin
            CestaZal:=CestaAkt2;
            CestaAKt2:=CestaAkt2^.dalsi;
          end;
          New(CestaAkt2);
          CestaAkt2^.Cil:=MestoAkt;
          CestaAkt2^.Vzdalenost:=CestaAkt^.Vzdalenost;
          CestaAkt2^.Vp:=CestaAkt^.Vp;
          CestaAkt2^.dalsi:=nil;
          If MestoZal^.CestaPrvni=nil then MestoZal^.CestaPrvni:=CestaAkt2 else CestaZal^.dalsi:=CestaAkt2;
        end;



        CestaAkt:=CestaAKt^.dalsi;
      end;
      MestoAkt:=MestoAkt^.dalsi;
    end;

    CestaZ.ItemIndex:=0;
    CestaDo.ItemIndex:=0;


end;

procedure TFOrm1.Showmap(UkazujCesty:Boolean;UkazujNazvy:Boolean);
Var MestoAkt,MestoAkt2:TMesta;
    CestaAkt:TCesta;
    MaxX,MaxY,MinX,MinY:Integer; {Pro urceni krajnich bodu na mape}
    pomerX,PomerY:Real;
    X,Y:Integer; {pomocne souradnice; setri vypocty}
    rect:TREct;
begin

    If MestoPrvni=nil then exit;
    Rect.Left:=0;
    Rect.Top:=0;
    Rect.Right:=mapa.width;
    Rect.Bottom:=mapa.Height;
    Mapa.Canvas.Brush.Color:=clwhite;
    Mapa.canvas.FillRect(rect);
    MestoAkt:=MestoPrvni;
    MaxX:=-999999;
    MaxY:=-999999;
    MinX:=-999999;
    MinY:=-999999;



    While MestoAkt<>nil do begin
      If MaxX< MestoAkt^.Koordinaty.X then MaxX:=MestoAkt^.Koordinaty.X;
      If (MinX> MestoAkt^.Koordinaty.X) or (MinX=-999999) then MinX:=MestoAkt^.Koordinaty.X;
      If MaxY< MestoAkt^.Koordinaty.Y then MaxY:=MestoAkt^.Koordinaty.Y;
      If (MinY> MestoAkt^.Koordinaty.Y) or (MinY=-999999) then Miny:=MestoAkt^.Koordinaty.Y;
      MestoAkt:=MestoAkt^.dalsi;
    end;

    mapa.Canvas.Pen.Color:=clblue;
    PomerX:=(mapa.Width-4)/ Abs(Abs(MinX)+Abs(MaxX));
    PomerY:=(mapa.Height-24) / (Abs(Abs(MinY)+Abs(MaxY)));
    If UkazujCesty then begin
      MestoAKt:=mestoPrvni;
      While MestoAkt<>nil do begin
       CestaAkt:=MestoAkt^.CestaPrvni;
       While CestaAkt<>nil do begin
        mapa.canvas.Pen.Color:=round(CestaAkt^.vp+256*CestaAkt^.Vp+65536*CestaAkt^.Vp);
        X:=2+round((MestoAkt^.Koordinaty.X-MinX)*PomerX);
        Y:=2+round((MestoAkt^.Koordinaty.Y-MinY)*PomerY);
        Mapa.Canvas.MoveTo(X,Y);
        MestoAkt2:=CestaAkt^.Cil;
        X:=2+round((MestoAkt2^.Koordinaty.X-MinX)*PomerX);
        Y:=2+round((MestoAkt2^.Koordinaty.Y-MinY)*PomerY);

        Mapa.Canvas.LineTo(X,Y);
        CestaAkt:=CestaAkt^.dalsi;
       end;
       MestoAkt:=MestoAKt^.dalsi;
      end;
    end;
    MestoAkt:=MestoPrvni;
    Mapa.canvas.pen.color:=clblack;
    While MestoAkt<> nil do begin
      Mapa.Canvas.Brush.Color:=clred;

      X:=2+round((MestoAkt^.Koordinaty.X-MinX)*PomerX);
      Y:=2+round((MestoAkt^.Koordinaty.Y-MinY)*PomerY);

      mapa.canvas.Ellipse(X-2,Y-2,X+2,y+2);
      Mapa.Canvas.Brush.Color:=clyellow;

      If UkazujNazvy then mapa.Canvas.TextOut(x,y,MestoAkt^.Nazev);
      mestoAkt:=MestoAKt^.dalsi;
    end;

end;

procedure TForm1.ZobrazitClick(Sender: TObject);
begin
  ShowMap(Cesty.Checked,Popisky.checked);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  ZobrazitClick(self);
end;

Function TForm1.Hodiny(HH:Real):String;
Var Vystup:String;
    MH:Real;
begin
    Vystup:=IntTOStr(Trunc(HH))+' H ';
    Mh:=(HH-Trunc(HH))*60;
    Vystup:=Vystup+IntToStr(round(MH))+' M';
    Hodiny:=Vystup;
end;

procedure TForm1.HledatClick(Sender: TObject);
Var Mesto1,Mesto2:TMesta;
    CestaAkt:TCesta;
    TrasaAkt:TTrasa;
begin
    zobrazitClick(self);
    Trasa.Zaznam.Lines.clear;

    {1. zdroj i cil jsou totozne}
    If CestaZ.Text=CestaDo.Text then begin
      Trasa.Zaznam.lines.Add('Nen teba nikam jezdit !!');
      Trasa.Show;
      exit;
    end;

    {2. Sousedni mesta}
    Mesto1:=MestoPrvni;
    While Mesto1.Nazev<>CestaZ.Text do Mesto1:=Mesto1.dalsi;
    Mesto2:=MestoPrvni;
    While Mesto2.Nazev<>CestaDo.Text do Mesto2:=Mesto2.dalsi;
    CestaAkt:=Mesto1.CestaPrvni;
    While CestaAkt<>nil do begin
      If CestaAkt^.Cil=Mesto2 then begin
        Trasa.Zaznam.lines.add('Cesta z '+Mesto1.Nazev+' do '+Mesto2.Nazev+' je dlouh '+FloatToStr(CestaAkt^.Vzdalenost)+' km a mla by trvat '+Hodiny(CestaAkt^.Vzdalenost/CestaAkt^.Vp));
        Trasa.Show;
        exit;
      end;
      CestaAkt:=CestaAkt^.dalsi;
    end;

    {3. Rozsirene hledani trasy}
    New(TrasaPrvni);
    TrasaPrvni^.Delka:=0;
    TrasaPrvni^.Spotreba:=0;
    TrasaPrvni^.Rychlost:=0;
    TrasaPrvni^.dalsi:=nil;
    TrasaPrvni^.dalsiKrok:=nil;
    TrasaPrvni^.predchoziKrok:=nil;
    Trasuj(TrasaPrvni,Mesto1,Mesto2);

    {Vypis}
    TrasaAkt:=TrasaPosledni;
    While TrasaAkt<>nil do begin
      Trasa.Zaznam.Lines.Insert(1,TrasaAkt^.Nazev);
      TrasaAkt:=TrasaAkt^.predchoziKrok;
    end;
    Trasa.show;
end;

Procedure TForm1.Trasuj(soucasnatrasa,odkud,kam:pointer);
Var MestoAkt,MestoKam:TMesta;
    CestaAkt:TCesta;
    SpotrebaAkt:TSpotreby;
    TrasaAkt,TrasaZal,TrasaDalsi:TTrasa;
    nepokracovat:Boolean;
begin
  MestoAkt:=odkud;
  If odkud=kam then begin
    TrasaPosledni:=SoucasnaTrasa;
    Trasa.Zaznam.Lines.Add('Nalezena cesta:');
    exit;
  end;
  TrasaAkt:=soucasnaTrasa;
  MestoAkt:=odkud;
  CestaAkt:=MestoAkt^.CestaPrvni;
  While CestaAkt<> nil do begin
    MestoKam:=CestaAkt^.Cil;
    TrasaZal:=TrasaAkt;
    nepokracovat:=false;

    {Kontrola bludneho kruhu}
    While TrasaZal<>nil do begin
      TrasaZal:=TrasaZal^.predchoziKrok;
      If (TrasaZal<>nil) and (TrasaZal^.Nazev=MestoKam^.Nazev) then begin
        nepokracovat:=true;
        break;
      end;
    end;

    TrasaAkt^.Nazev:=MestoKam^.Nazev;
    If nepokracovat=false then begin
      {Dalsi krok}
      TrasaZal:=TrasaAkt;
      New(TrasaDalsi);
      TrasaDalsi^.dalsi:=nil;
      TrasaDalsi^.predchoziKrok:=TrasaZal;
      Trasuj(TrasaDalsi,MestoKam,kam);

      If Trasa.zaznam.Lines[trasa.Zaznam.lines.Count-1]='Nalezena cesta:' then exit;

    end;

    {Dalsi varianta cesty}
    TrasaZal:=TrasaAkt;
    New(TrasaAkt);
    TrasaAkt^.dalsi:=nil;
    TrasaAkt^.dalsiKrok:=nil;
    TrasaAKt^.predchoziKrok:=TrasaZal^.predchoziKrok;
    TrasaZal^.dalsi:=TrasaAkt;
    CestaAkt:=CestaAkt^.dalsi;
  end;
end;

Procedure TForm1.ZobrazTrasu;
Var MestoAkt,MestoAkt2:TMesta;
    MaxX,MaxY,MinX,MinY:Integer; {Pro urceni krajnich bodu na mape}
    pomerX,PomerY:Real;
    X,Y:Integer; {pomocne souradnice; setri vypocty}
    rect:TREct;
    TrasaAkt:TTrasa;
    prvni:boolean;
begin
    {Vykresli modre cestu}
    If MestoPrvni=nil then exit;
    Rect.Left:=0;
    Rect.Top:=0;
    Rect.Right:=mapa.width;
    Rect.Bottom:=mapa.Height;
    MestoAkt:=MestoPrvni;
    MaxX:=-999999;
    MaxY:=-999999;
    MinX:=-999999;
    MinY:=-999999;



    While MestoAkt<>nil do begin
      If MaxX< MestoAkt^.Koordinaty.X then MaxX:=MestoAkt^.Koordinaty.X;
      If (MinX> MestoAkt^.Koordinaty.X) or (MinX=-999999) then MinX:=MestoAkt^.Koordinaty.X;
      If MaxY< MestoAkt^.Koordinaty.Y then MaxY:=MestoAkt^.Koordinaty.Y;
      If (MinY> MestoAkt^.Koordinaty.Y) or (MinY=-999999) then Miny:=MestoAkt^.Koordinaty.Y;
      MestoAkt:=MestoAkt^.dalsi;
    end;

    mapa.Canvas.Pen.Color:=clblue;
    mapa.canvas.Brush.color:=clBlue;
    PomerX:=(mapa.Width-4)/ Abs(Abs(MinX)+Abs(MaxX));
    PomerY:=(mapa.Height-24) / (Abs(Abs(MinY)+Abs(MaxY)));

    TrasaAkt:=TrasaPosledni;
    TrasaAkt:=TrasaAkt^.predchoziKrok;
    Prvni:=true;
    While TrasaAkt<>nil do begin
      MestoAKt:=mestoPrvni;
      While (TrasaAkt^.nazev<>'') and (mestoAkt^.Nazev<> TrasaAkt^.Nazev) do MestoAkt:=MestoAkt^.dalsi;
      X:=2+round((MestoAkt^.Koordinaty.X-MinX)*PomerX);
      Y:=2+round((MestoAkt^.Koordinaty.Y-MinY)*PomerY);
      If Prvni then Mapa.Canvas.MoveTo(X,Y) else
        Mapa.Canvas.LineTo(X,Y);
      Prvni:=false;
      TrasaAkt:=TrasaAkt^.predchoziKrok;
    end;
    MestoAkt:=MestoPrvni;
    While MestoAkt^.Nazev<>CestaZ.Text do MestoAkt:=MestoAkt^.dalsi;
    X:=2+round((MestoAkt^.Koordinaty.X-MinX)*PomerX);
    Y:=2+round((MestoAkt^.Koordinaty.Y-MinY)*PomerY);
    Mapa.Canvas.LineTo(X,Y);

end;

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  resize:=false;
end;

end.
